
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileBoxPlotBoxAttributes.h
    \brief Definition of BoxPlotBox Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/
   

#ifndef BoxPlotBoxAttributes_H
#define BoxPlotBoxAttributes_H

#include "magics.h"
#include "Colour.h"
#include "BoxPlotBasicItem.h"
namespace magics {

class XmlNode;
class BoxPlotBoxAttributes 
{
public:
//  --  constructor
    BoxPlotBoxAttributes();
    
//  --  destructor
    virtual ~BoxPlotBoxAttributes();
    
    virtual void set(const std::map<std::string, std::string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const BoxPlotBoxAttributes&);
    virtual bool accept(const std::string&);

    void setTag(const std::string& tag) { tag_ = tag; }

public:
	//  --  method
	virtual void print(std::ostream&) const;
	virtual void toxml(std::ostream& out) const;
	//  --  members:
	string tag_;
	double width_;
	unique_ptr<Colour> colour_;
	unique_ptr<NoBoxPlotBoxBorder> border_;
	unique_ptr<NoBoxPlotMedian> median_;
	 

private:
	friend ostream& operator<<(ostream& s,const BoxPlotBoxAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif

